from functools import partial

import xbmcgui
from resources.lib.kodilogging import logger
from resources.lib.utils.kodiutils import get_info


class Storage:
    def __init__(self):
        self._id = get_info('id')
        self._window = xbmcgui.getCurrentWindowId()

    def __setitem__(self, key, value):
        logger.debug('[Cache:%s] Set cache' % key)
        xbmcgui.Window(self._window).setProperty(key, repr(value))

    def __getitem__(self, key):
        logger.debug('[Cache:%s] Get cache' % key)
        val = xbmcgui.Window(self._window).getProperty(key)
        return eval(val) if val else val

    def __delitem__(self, key):
        xbmcgui.Window(self._window).setProperty(key, None)

    def get(self, key):
        try:
            return self[key]
        except:
            self[key] = {}
            return self[key]

    def dynamic(self, key):
        return partial(self.get, key)


storage = Storage()
